Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package plugins
  Definition Classes
    nsc
- MissingPluginException
- OutputFileWriter
- Plugin
- PluginComponent
- PluginDescription
- PluginLoadException
- Plugins

t

scala.tools.nsc.plugins

# Plugins

###

#### trait Plugins extends AnyRef

Support for run-time loading of compiler plugins.

Self Type
  Global
Source
  Plugins.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Global, compiler, DocParser, ScaladocGlobal, ScaladocGlobalTrait, Global, ReplGlobal, ReflectGlobal
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Plugins
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Plugins toany2stringadd[Plugins] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Plugins, B)
   Implicit
     This member is added by an implicit conversion from Plugins toArrowAssoc[Plugins] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def computePluginPhases(): Unit

   Extract all phases supplied by plugins and add them to the phasesSet.

   Extract all phases supplied by plugins and add them to the phasesSet.

   Attributes
     protected
   See also

     phasesSet

9.  def ensuring(cond: (Plugins) => Boolean, msg: => Any): Plugins
   Implicit
     This member is added by an implicit conversion from Plugins toEnsuring[Plugins] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (Plugins) => Boolean): Plugins
    Implicit
      This member is added by an implicit conversion from Plugins toEnsuring[Plugins] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: => Any): Plugins
    Implicit
      This member is added by an implicit conversion from Plugins toEnsuring[Plugins] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): Plugins
    Implicit
      This member is added by an implicit conversion from Plugins toEnsuring[Plugins] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
15.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
16.  def findMacroClassLoader(): ClassLoader

    Obtains a `ClassLoader` instance used for macro expansion.

    Obtains a `ClassLoader` instance used for macro expansion.

    By default a new `ScalaClassLoader` is created using the classpath from global and the classloader of self as parent.

    Mirrors with runtime definitions (e.g. Repl) need to adjust this method.

17.  def findPluginClassLoader(classpath: Seq[Path]): ClassLoader

    Locate or create the classloader to load a compiler plugin with `classpath`.

    Locate or create the classloader to load a compiler plugin with `classpath`.

    Subclasses may override to customise the behaviour. The returned classloader must return the first from plugin descriptor from `classpath` when `getResource("scalac-plugin.xml")` is called.

    Attributes
      protected
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Plugins toStringFormat[Plugins] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
20.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
21.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
22.  def loadPlugins(): List[Plugin]

    Load all available plugins.

    Load all available plugins. Skips plugins that either have the same name as another one, or which define a phase name that another one does.

    Attributes
      protected
23.  def loadRoughPluginsList(): List[Plugin]

    Load a rough list of the plugins.

    Load a rough list of the plugins. For speed, it does not instantiate a compiler run. Therefore it cannot test for same-named phases or other problems that are filtered from the final list of plugins.

    Attributes
      protected
24.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
25.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
26.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
27.  def pluginDescriptions: String

    A description of all the plugins that are loaded

28.  def pluginOptionsHelp: String

    Summary of the options for all loaded plugins

29.  lazy val plugins: List[Plugin]
30.  lazy val roughPluginsList: List[Plugin]
    Attributes
      protected
31.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
32.  def toString(): String
    Definition Classes
      AnyRef → Any
33.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
34.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
35.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (Plugins, B)
   Implicit
     This member is added by an implicit conversion from Plugins toArrowAssoc[Plugins] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromPlugins to any2stringadd[Plugins]

### Inherited by implicit conversion StringFormat fromPlugins to StringFormat[Plugins]

### Inherited by implicit conversion Ensuring fromPlugins to Ensuring[Plugins]

### Inherited by implicit conversion ArrowAssoc fromPlugins to ArrowAssoc[Plugins]

### Ungrouped